#include "internal.h"

SV_variable *SV_variable_new()
{
	SV_variable *v = malloc(sizeof(SV_variable));
	SV_assert_memory(v);
	
	v->simulation = NULL;
	v->id = 0;
	v->derivative = NULL;
	
	return v;
}

void SV_variable_free(SV_variable *var)
{
	SV_assert_sanity(var);
	SV_assert(var->simulation == NULL, "Trying to free a variable that is part of a simulation.");
	
	free(var);
}

void SV_variable_set_derivative(SV_variable *var, SV_variable *derivative)
{
	SV_assert_sanity(var);
	var->derivative = derivative;
}

unsigned int SV_variable_get_id(SV_variable *var)
{
	SV_assert_sanity(var);
	SV_assert(var->simulation!=NULL, "Trying to get the ID of a variable that is not part of a "
	"simulation. Variables only have meaningful IDs if they are part of simulations.");
	return var->id;
}